package eu.chorevolution.vsb.playgrounds.clientserver.rest;

import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.restlet.Client;
import org.restlet.Context;
import org.restlet.Request;
import org.restlet.Response;
import org.restlet.data.MediaType;
import org.restlet.data.Method;
import org.restlet.data.Protocol;

public class RestClientExample {
	
	public static void main(String[] args) {
		
        JSONObject obj = new JSONObject();
        obj.put("lat", "57.6198.7361989724.11.972487");
        obj.put("lon", "57.7361989724");
        obj.put("op_name", "bridgeNextClosure");
        String content = obj.toJSONString();
		String url = "http://localhost:8080";
		Response resp = RestClientExample.post(url, content);
		System.out.println(resp.getEntityAsText());
	}
	

	private static Response post(String url, String content){
		
		Request request = new Request();
		request.setResourceRef(url);
		request.setMethod(Method.POST);
		request.setEntity(content, MediaType.APPLICATION_JSON);
		Context ctx = new Context();
		Client client = new Client(ctx, Protocol.HTTP);
		System.out.println("request: " + request);
		System.out.println("request data: " + request.getEntityAsText());
		return client.handle(request);
	}
	
	private static Response get(String url, String content){
		
		Request request = new Request();
		request.setResourceRef(url);
		request.setMethod(Method.GET);
		Client client = new Client(new Context(),Protocol.HTTP);
		return client.handle(request);
	}

}
